import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;
import java.util.LinkedList;
import java.util.PriorityQueue;

/**
 * Eine Klasse zur Darstellung eines Graphen.
 */
public class Graph
{
    private int breite, hoehe, anzahl;
    private String farbe;

    /**
     * Erzeuge eine neue Knotenliste mit anzahl vielen Punkten.
     */
    public Graph(int anzahl)
    {
        this.anzahl = anzahl;
        breite = 600;
        hoehe = 600;
        farbe = "blau";
        Kante.setzeDimension(breite, hoehe);
        Knoten.setzeDimension(breite, hoehe);
        for (int i=0;i<anzahl;i++){ new Knoten(); }
    }
    
    /**
     * Erzeuge einen Testgraphen mit 5 Knoten.
     */
    public Graph()
    {
        this.anzahl = 5;
        breite = 600;
        hoehe = 600;
        farbe = "blau";
        Kante.setzeDimension(breite, hoehe);
        Knoten.setzeDimension(breite, hoehe);
        new Knoten(20, 20);
        new Knoten(440, 60);
        new Knoten(120, 220);
        new Knoten(220, 560);
        new Knoten(540, 380);
    }
    
    /**
     * verknuepft alle Knoten zu einem Graphen.
     */
    public void vollstaendig(){
        Kante.loescheKanten();
        for (int i=0;i<anzahl;i++)
        for (int j=i+1;j<anzahl;j++)
        new Kante(Knoten.gibKnoten(i),Knoten.gibKnoten(j));
    }
    
    // **************** Abschnitt fuer die Suche ******************
    
    /**
     * fuehrt eine greedy - Suche fuer einen Rundweg vom Startknoten aus
     * mit Auswahl der kuerzesten Nachfolgekante durch.
     */
    public void greedySucheRund(){
        LinkedList<Knoten> weg=new LinkedList<Knoten>();
        vollstaendig();zeichne();Leinwand.gibLeinwand().warte(2000);
        Knoten start=Knoten.gibKnoten(0);
        Kante aktuelleKante=start.gibSortierteKanten().peek();
        Knoten weiter=aktuelleKante.andererKnoten(start);
        weg.add(weiter); // das startproblem ist noch nicht geloest!!!
        while (weg.size()<anzahl-1){
            PriorityQueue<Kante> nachfolgeKanten=new PriorityQueue<Kante>(weiter.gibSortierteKanten());
            Kante kante=nachfolgeKanten.poll();
            Knoten andererKnoten=kante.andererKnoten(weiter);
            while (weg.contains(andererKnoten)||andererKnoten.equals(start)) {
                kante=nachfolgeKanten.poll();
                andererKnoten=kante.andererKnoten(weiter);
            }
            weiter=andererKnoten;
            weg.add(weiter);
        }
        Kante.loescheKanten();
        weg.addFirst(start);weg.addLast(start);
        for (int i=1;i<weg.size();i++) new Kante(weg.get(i-1), weg.get(i));
    }
      
    // **************** Abschnitt fuer die Grafik *****************
    /**
     * Berechnet den zu zeichnenden Graphen anhand der gegebenen Daten.
     */
    protected Shape gibAktuelleFigur()
    {
        GeneralPath graph = new GeneralPath();
        for (int i=0;i<Kante.gibAnzahl();i++){
            graph.append(Kante.gibKante(i), false);
        }
        return graph;
    }
  
    /**
     * Zeichne dieses Objekt mit seinen aktuellen Werten auf den Bildschirm.
     */
    public void zeichne()
    {
        Shape figur = gibAktuelleFigur();
        Leinwand leinwand = Leinwand.gibLeinwand();
        leinwand.zeichne (
          this,           // leinwand kennt das Objekt
          farbe,          // definiert seine Zeichenfarbe
          figur);         // definiert seinen grafischen Aspekt
    }

    /**
     * Loesche diesen Graphen vom Bildschirm.
     */
    public void loesche()
    {
        Leinwand leinwand = Leinwand.gibLeinwand();
        leinwand.entferne(this);
    }
}

